# the title

## Part One \: try


Ut rutrum faucibus lectus ut dapibus. Nunc consectetur scelerisque metus, a sodales enim elementum in. Ut ut nunc quis massa mattis interdum. Donec in tristique ipsum, eu gravida risus. Aenean iaculis est et magna consectetur congue. Nullam luctus id justo a egestas. Nam placerat orci quis rutrum placerat. Ut pellentesque tellus eu tortor iaculis blandit. Donec mattis eros id vehicula volutpat. Cras magna libero, vulputate in tristique vel, mattis non purus. Sed eget augue vitae lorem pellentesque auctor.

Note:Nulla facilisi. In nec rutrum augue.:{.footnote} Praesent sed tincidunt dui, a tempor metus. Pellentesque venenatis, sem vitae rhoncus interdum, nibh nisi iaculis neque, vitae pulvinar tortor libero vel neque. Nulla fringilla suscipit nulla, non fermentum sapien dapibus sit amet. Fusce tempor scelerisque diam, in ornare dolor ornare eget. Aenean eu placerat lacus. Suspendisse fringilla lorem et tempor vulputate. Etiam iaculis libero libero, sed placerat nisl pulvinar et. Proin sed nisi sed magna tempus aliquam.

Ut nec eleifend arcu. Nulla:foot2:{.footnote} facilisi. Duis lectus ligula, auctor vel imperdiet ac, pharetra dignissim nisi. Praesent faucibus tellus eget dui tincidunt semper. Sed quis tellus elit. Ut luctus non quam sit amet cursus. Nunc mauris nunc, semper eget imperdiet sit amet, molestie non nunc.

Maecenas vel porttitor diam, sed lobortis nisl. Morbi hendrerit consequat augue porta tristique. Praesent accumsan tortor sed risus pellentesque blandit. Vestibulum laoreet facilisis placerat. Curabitur sed turpis purus. Nulla sed purus vel augue eleifend convallis quis gravida arcu. Sed nisi quam, placerat eget ex ut, ullamcorper pulvinar nisi. Ut eu elit tristique, vulputate mi pulvinar, pellentesque lacus. Nunc dictum, dui eu condimentum finibus, magna lorem venenatis libero, a sagittis felis urna sit amet nunc. Nullam vitae dolor at ipsum tempus aliquet. Vivamus vehicula ipsum non auctor cursus. Nunc sollicitudin ex ac neque vehicula sodales. Quisque a orci orci.

Duis efficitur in justo quis congue. Duis blandit neque condimentum auctor tristique. Phasellus suscipit, quam non luctus maximus, ligula tortor porta magna, eu iaculis nunc sem at mi. Proin faucibus massa et mattis dignissim. Cras in lacus scelerisque, consequat orci sit amet, euismod ipsum. Sed a mauris tempus, vulputate mi ac, tincidunt diam. Vestibulum ac tellus vehicula arcu blandit luctus et sed elit. Ut vel tellus vel elit suscipit feugiat. Nam malesuada molestie felis vel venenatis.

## Part Two \: Maybe

Cras porttitor sagittis enim at efficitur. In hac habitasse platea dictumst. Vivamus sagittis nulla ut nisi rutrum, vitae commodo purus egestas. Sed elementum porttitor ipsum volutpat rhoncus. Donec vel ipsum rhoncus, feugiat mauris bibendum, dictum ex. Donec tempus semper eros, convallis varius mauris interdum eget. Praesent dapibus id libero a efficitur. Mauris rhoncus finibus molestie. Ut dignissim sed lorem ut vestibulum. In ornare ipsum et tortor blandit, vitae tincidunt dolor pellentesque.

Sed tempus lacus ac mauris porta, sit amet congue leo consectetur. Aliquam egestas nec magna ac pretium. In dictum magna quis posuere finibus. Mauris hendrerit metus eget enim efficitur, eleifend sodales purus fermentum. Nullam cursus fermentum porttitor. Nullam venenatis quis lectus quis elementum. Duis vestibulum congue nisi, nec suscipit odio convallis ut. Sed sagittis leo non nisi vehicula volutpat. Integer molestie scelerisque ullamcorper. Etiam convallis purus id tempus ullamcorper. Donec convallis lacinia erat, at scelerisque sapien rhoncus eu. Phasellus eget sapien faucibus, fermentum lacus at, ornare nisl. Donec ac viverra nibh.

Sed arcu neque, volutpat semper est vitae, ornare congue nunc. Nullam vel elit in lorem pharetra lacinia quis at eros. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Proin ante nibh, sodales vulputate orci ullamcorper, feugiat maximus nisl. Vivamus sed fermentum sapien, ac lobortis tortor. Pellentesque eros sapien, maximus eu fermentum non, finibus et nisi. Nunc quis massa leo. Pellentesque quis sem in orci dapibus mollis eget ac eros.


Mauris eu quam a arcu feugiat finibus. In eu cursus justo. Maecenas consequat ligula sit amet est aliquam sodales. Curabitur sed pellentesque arcu. Ut consequat nisi ipsum, at euismod quam finibus eu. Donec augue lectus, rhoncus ac nunc id, convallis luctus diam. Fusce ut imperdiet enim. Integer sem ligula, molestie egestas imperdiet vitae, dignissim sit amet lorem. Proin sed lacus luctus, auctor diam a, aliquam sapien. Aliquam dignissim, metus sit amet bibendum commodo, velit nunc cursus purus, ac gravida dolor diam a tellus. Nam non nunc et urna dignissim maximus.

Aenean eleifend enim eu sem convallis consequat. Donec sagittis quam sit amet sapien egestas, vehicula tincidunt elit iaculis. Sed suscipit finibus libero vitae faucibus. Sed diam lorem, dapibus et est sit amet, tempor condimentum est. Curabitur luctus suscipit nunc vel pellentesque. Praesent fringilla vitae diam id finibus. Nunc magna nibh, scelerisque quis molestie ultrices, lacinia vel est.

Integer et lacinia nisi, ac condimentum nisi. Praesent congue at sapien nec tristique. Aenean nec suscipit nunc, quis ultricies arcu. Curabitur dapibus maximus gravida. Phasellus eu mollis orci. Aliquam id vehicula mauris. Vestibulum maximus justo eu dapibus ultricies. Fusce metus mauris, pulvinar eu euismod sed, scelerisque eleifend diam.

## Part Three \: End

Mauris maximus eu risus sit amet molestie. Etiam sem purus, pellentesque sed ultrices nec, volutpat id eros. Donec quis dapibus est. Curabitur quis lacinia augue. Quisque finibus mauris odio. Nullam ornare risus ipsum, in aliquam lacus maximus a. Cras fringilla aliquet eros, in tincidunt turpis rutrum at. Quisque pellentesque justo et accumsan varius. Ut at sem rhoncus elit interdum gravida sed in lorem. Donec tincidunt mi sed sem dapibus viverra. In et urna non sapien blandit scelerisque. Maecenas non nulla non est fringilla molestie.

Nulla augue nisi, fermentum a pulvinar sed, varius eu metus. Morbi blandit tincidunt luctus. Aliquam quis pretium nisl, et tempor arcu. Maecenas quis metus consequat, sodales diam vel, convallis justo. Praesent vitae nulla at enim venenatis sollicitudin et quis nisl. Nunc condimentum nisi at nisl iaculis, id auctor enim consectetur. Morbi accumsan dui est, non gravida dui iaculis vitae. Donec ex est, egestas vitae dui sed, ornare hendrerit massa. Integer iaculis, sapien non egestas cursus, magna dolor consectetur leo, auctor mattis elit libero id dui. Integer pretium augue in placerat rutrum. Donec semper, velit in ultricies facilisis, dolor felis gravida arcu, eget malesuada libero mauris nec ligula. Suspendisse ut ultricies ex, eget congue lorem. Duis bibendum nec odio et varius. Phasellus dignissim imperdiet est ac suscipit. Sed laoreet justo et pellentesque malesuada. Duis condimentum porta malesuada.

Maecenas aliquet vehicula libero at viverra. Aliquam auctor neque nec orci tristique, eget vulputate erat semper. Quisque rutrum, lectus vitae lacinia euismod, nulla libero venenatis mauris, sed fringilla orci nisl eget tortor. Fusce dapibus dignissim nunc vel sodales. Cras tincidunt tortor nisl, ut mollis urna malesuada molestie. Quisque at arcu eget lectus bibendum ornare eget eu sapien. Vivamus vestibulum tincidunt risus venenatis mollis. Vivamus suscipit id lacus eget luctus. Donec porta efficitur leo a consequat.

Suspendisse non eros sit amet ipsum rutrum luctus. Vestibulum diam velit, varius in porta non, lobortis nec sem. Aenean fringilla faucibus lectus eu iaculis. Pellentesque mattis ultrices semper. Nunc elementum rutrum justo, eget dictum dolor condimentum ac. Suspendisse condimentum mauris vitae risus accumsan, vulputate malesuada eros scelerisque. Curabitur sodales, risus id molestie ornare, diam lacus pellentesque augue, facilisis consectetur sem ligula a felis. 

# The Main 

## Again

Cras porttitor sagittis enim at efficitur. In hac habitasse platea dictumst. Vivamus sagittis nulla ut nisi rutrum, vitae commodo purus egestas. Sed elementum porttitor ipsum volutpat rhoncus. Donec vel ipsum rhoncus, feugiat mauris bibendum, dictum ex. Donec tempus semper eros, convallis varius mauris interdum eget. Praesent dapibus id libero a efficitur. Mauris rhoncus finibus molestie. Ut dignissim sed lorem ut vestibulum. In ornare ipsum et tortor blandit, vitae tincidunt dolor pellentesque.

Sed tempus lacus ac mauris porta, sit amet congue leo consectetur. Aliquam egestas nec magna ac pretium. In dictum magna quis posuere finibus. Mauris hendrerit metus eget enim efficitur, eleifend sodales purus fermentum. Nullam cursus fermentum porttitor. Nullam venenatis quis lectus quis elementum. Duis vestibulum congue nisi, nec suscipit odio convallis ut. Sed sagittis leo non nisi vehicula volutpat. Integer molestie scelerisque ullamcorper. Etiam convallis purus id tempus ullamcorper. Donec convallis lacinia erat, at scelerisque sapien rhoncus eu. Phasellus eget sapien faucibus, fermentum lacus at, ornare nisl. Donec ac viverra nibh.

Sed arcu neque, volutpat semper est vitae, ornare congue nunc. Nullam vel elit in lorem pharetra lacinia quis at eros. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Proin ante nibh, sodales vulputate orci ullamcorper, feugiat maximus nisl. Vivamus sed fermentum sapien, ac lobortis tortor. Pellentesque eros sapien, maximus eu fermentum non, finibus et nisi. Nunc quis massa leo. Pellentesque quis sem in orci dapibus mollis eget ac eros.


# EPE - Ecran-Papier-Editer

## Simple Markdown to Paged.js sample

The Markdown format is used to enable the rapid manipulation of long texts. It's a first introduction to web technologies for producing formatted objects intended for printing.
Paged.js takes care of the layout in the browser. A PDF can then be printed using the print function and by choosing PDF as the print destination.

[https\://gitlab.com/esad-gv1/epe/templatepagedjs_ws](https://gitlab.com/esad-gv1/epe/templatepagedjs_ws)

## Usage

Download this folder (in zip format, for example).

### Modify text and image content

Modify files in the md folder\:

- `md/cover.md` contains data dedicated to the cover page, designed to fit on a single page,
- `md/main.md` contains the main content of the book, which will be paginated automatically,
- `md/back.md` contains the 4th cover.

### Defining styles

To define styles for the pages and their content, you need to modify the `css` files corresponding to the `.md` file:

- `css/cover.css`
- `css/style.css`
- `css/back.css`

The `css/fonts` folder contains the font files to be used in the project.

## Markdown - Specific extensions used in this template

### Attributes, div and span

Several plugins are available with markdown-it for structuring content. 

#### Add a `class` or an `id`.
In `markdown`\:
```md
## Heading 2{#first-part}

This is a paragraph{.content}
```
`html` conversion\:

```html
<h2 id="first-part">Title 2</h2>
<p class=" content">This is a paragraph</p>
```

#### Div
To create a div to group several content elements in `markdown`\: 
```md
:::
## Heading 2

This is a paragraph.

This is another paragraph.
:::
```

`html` conversion\:

```html
<div>
    <h2>Titre 2</h2>
    <p>Ceci est un paragraphe.</p>
    <p>Ceci est un autre paragraphe.</p>
</div>
```

To add a class or a `#id` to your `.div`, follow the synthax below:
```md
::: .class
## Heading 2

This is a paragraph.

This is another paragraph.
:::

::: #id
## Heading 2

This is a paragraph.

This is another paragraph.
:::

```
#### Span

To add spans, use the following syntax:

`This is a paragraph with :something: to isolate.`

It's possible to add a `class` or an `id`:

`This is a :paragraph:{#id} with :something:{.class} to isolate.`

`html` conversion\:
```html
<p>This is a <span id="id"></span> with some <span class="class">thing</span> to isolate</p>
```

## Technical choices

```{.tree}
.
├── css  
│   ├── back.css  
│   ├── cover.css
│   ├── fonts
│   │   └── Inter-VariableFont_slnt_wght.ttf
│   └── style.css
├── index.html
├── md
│   ├── back.md
│   ├── cover.md
│   └── main.md
├── readme.md
├── script.js
└── vendors
    ├── css
    │   ├── paged-preview.css
    │   └── pagedjs-interface.css
    └── js
        ├── markdown-it-attrs.js
        ├── markdown-it-bracketed-spans.js
        ├── markdown-it-container.js
        ├── markdown-it-footnote.js
        ├── markdown-it-span.js
        ├── markdown-it.js
        └── paged.polyfill.js
```

This template uses a basic ES5 structure. `index.html` file uses ```<script>``` tags to import external scripts :

```html
<script src="vendors/js/markdown-it.js"></script>
<script src="vendors/js/markdown-it-footnote.js"></script>
<script src="vendors/js/markdown-it-attrs.js"></script>
<script src="vendors/js/markdown-it-container.js"></script>
<script src="vendors/js/markdown-it-span.js"></script>
```

The 3 parts that compose the printed booklet are defined by 3 HTML `div` elements with specific classes and id for each : `cover`,`content`,`back`. These are used to define styles in the css files.

The `script.js` file contains the script that instanciates and configure markdown-it and its plug-ins, loads the content of the 3 markdown files that the user edits, then loads the Paged.js polyfill that will automatically get the body content to paginate and preview it.

## Credits

- [Markdown-it](https://www.npmjs.com/package/markdown-it) for converting markdown to html in the browser;
- [Paged.js](https://pagedjs.org) for printed page layout and pdf generation;

## Authors
Dominique Cunin, Quentin Juhel, Cédric Rossignol-Brunet

{.break}

{.break}

# EPE templates

## Advanced Template written in ES6

This template aims to make an interactive website printable. Any kind of elements composing a web page can be given to Paged.js for pagination. Therefore, any kind of website could be printable, wether its content is static (usual HTML), generated from server side or through a local algorithm of any kind (using JavaScript).
Furthermore, as Paged.js can be extended thanks to a handler system, special processes to apply on the pagination execution can be programmed as well. To make it easier to build, a simple system of custom handlers has been defined in this template to help creative coders to make their own.

To give the EPE tools some coherence, the same structure used in [basictemplatees6](https://gitlab.com/esad-gv1/epe/basictemplatees6) is used, but it's only to give some sample usage and is meant to be changed accordingly to your own project.

[https\://gitlab.com/esad-gv1/epe/advancedtemplatees6](https://gitlab.com/esad-gv1/epe/advancedtemplatees6)

## Usage

Download this folder (in zip format, for example).

`index.html` uses an `importmap` to use the `esm` version of Paged.js, that is far more flexible than the polyfill version we use in the basic templates.

```html
<script type="importmap">
{
    "imports" : {
        "pagedjs" : "./vendors/js/paged.esm.js"
    }
}
</script>
```
The main `script.js` is loaded as a `module` to make the whole chain ES6 compilant.

markdown files are in the `md` folder and loaded dynamically :

```javascript
//markdown files to load
const mdFilesList = ["md/cover.md", "md/main.md", "md/back.md"];
```

Their content is converted by `markdown-it` and used to fill the 3 elements inside prepared in the `body` by the `layoutHTML` function defined in the script.

The `layoutHTML` function is called automatically on page loading, **but you could call it at any other moment you want**. It is designed to synchronously \:

* load the md files;
* convert md to html
* fill the html elements in the `body`
* clone all the elements and keep them in an array

The results is the rendering of the md files in the page and to keep a clone of them for a later process, i.e. pagination with Paged.js.

The `paginate.js` file contains all the Paged.js related code. The `paginate` function of it is exported to be called at any time, by any handler you want. It is designed to maintain a `DocumentFragment` element internally that can be filled by an arbitrary array of elements :

```javascript
export async function paginate(elementsList, styleList)
```

This `DocumentFragment` is passed to the Paged.js Previewer, along with user defined styles. Note that this will wipe out the body content to let the Paged.js Previewer fill the `document.body`.

## Handlers

`HandlerSkeleton.js` is a simple file that demonstrate how to use a handler to customize some part of the pagination process made by Paged.js. This file is meant to be duplicated and renamed to your convenience.
The EPE dev team is using this system to propose some custom extensions of Paged.js, like a highlighter for margins or a layer system.

To use a Handler, it must be imported in the `paginate.js` file then registered in the Paged.js handler system :

```javascript
import { HandlerSkeleton } from "./HandlerSkeleton.js";

const paged = new Previewer();
//register a handler to define hooks on a specific method it defines
registerHandlers(HandlerSkeleton);s
```

```{.tree}
.
├── css
│   ├── back.css
│   ├── cover.css
│   ├── fonts
│   │   └── Inter-VariableFont_slnt_wght.ttf
│   └── style.css
├── index.html
├── js
│   ├── HandlerSkeleton.js
│   ├── paginate.js
│   └── utils.js
├── md
│   ├── back.md
│   ├── cover.md
│   └── main.md
├── readMe.md
├── script.js
└── vendors
    ├── css
    │   ├── paged-preview.css
    │   └── pagedjs-interface.css
    └── js
        ├── markdown-it-attrs.js
        ├── markdown-it-bracketed-spans.js
        ├── markdown-it-container.js
        ├── markdown-it-footnote.js
        ├── markdown-it-span.js
        ├── markdown-it.js
        ├── paged.esm.js
```

## Credits

* [Markdown-it](https://www.npmjs.com/package/markdown-it) for converting markdown to html in the browser;
* [Paged.js](https://pagedjs.org) for printed page layout and pdf generation;

## Authors

Dominique Cunin, Raphael Bottura

{.break}

# EPE - Ecran-Papier-Editer

# pagePosition

A set of python scripts for manipulating and imposing a pdf file in order to print a booklet.

[https://gitlab.com/esad-gv1/epe/pageposition](https://gitlab.com/esad-gv1/epe/pageposition)

## Requirements

* python 3+
* [pypdf](https://pypi.org/project/pypdf/)

## Usage

If your pages are not in a standard format :

* pdfSize.py : First, use pdfSize.py to put your pages in a standard format.
* pdfBooklet.py : Impose your file with pdfBooklet.py. It's ready to print on your printer.

### pdfSize.py

![pdfSize](img/pdfSize.png)

pdfSize is a script for resizing pdf pages to a standard format (A4, A5, ...).

* put pdf in the "pdf/" folder :

`python pdfSize.py pdfName.pdf A`

New pdf is in `output_pdfSize/`

Accepted arguments other than A4 are A3 or A5. Indicate the format in which you wish to insert your pdf.

### pdfBooklet.py

![pdfSize](img/pdfBooklet.png)

pdfBooklet.py is a script that allows you to impose standard page formats (A3, A4, A5) for booklet printing.

* put pdf in the "pdf/" folder :

`python pdfBooklet.py pdfName.pdf A4`

New pdf is in `output_booklet/`

Accepted arguments other than A4 are A3 or A5. Indicate the page format of the pdf you wish to modify.

### pdfInvert.py

pdfInvert.py is a script is a script for reversing the page order of your pdf file.

* put pdf in the "pdf/" folder :

`python pdfInvert.py pdfName.pdf`

New pdf is in `output_invert/`

### pdfMerge.py

pdfMerge.py is a script for merging two pdf files one after the other.

* put pdf in the "pdf/" folder :

`python pdfMerge.py pdfName01.pdf pdfName02.pdf`

New pdf is in `output_merge/`

## Author
Cédric Rossignol-Brunet
